SystemOrganization addCategory: #'MonticelloFileTree-Core'!

MCWriter subclass: #MCFileTreeAbstractStWriter
	instanceVariableNames: 'stWriter initializers orderedClassNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

!MCFileTreeAbstractStWriter class methodsFor: 'writing' stamp: 'dkh 3/1/2012 14:27:24'!
on: aStream
    ^ (MCFileTreePackageStructureStWriter useSnapShotWriter
        ifTrue: [ MCFileTreeStSnapshotWriter ]
        ifFalse: [ MCFileTreeStWriter ]) new stream: aStream! !

!MCFileTreeAbstractStWriter class methodsFor: 'accessing' stamp: 'dkh 3/1/2012 14:27:24'!
readerClass
	^ MCStReader! !

!MCFileTreeAbstractStWriter methodsFor: 'private' stamp: 'dkh 3/1/2012 14:27:24'!
directoryForDirectoryNamed: directoryNameOrPath
    ^ directoryNameOrPath = '.'
        ifTrue: [ stream packageFileDirectory ]
        ifFalse: [ stream subPackageFileDirectoryFor: directoryNameOrPath ]! !

!MCFileTreeAbstractStWriter methodsFor: 'private' stamp: 'dkh 3/1/2012 14:27:24'!
fileNameForSelector: selector
    ^ selector == #'/'
        ifTrue: [ 'encoded slash' ]
        ifFalse: [ selector ]! !

!MCFileTreeAbstractStWriter methodsFor: 'initialize-release' stamp: 'dkh 3/1/2012 14:27:24'!
initialize
    stWriter := MCFileTreePackageStructureStWriter new
        initializers: (initializers := Set new);
        yourself.
    orderedClassNames := OrderedCollection new! !

!MCFileTreeAbstractStWriter methodsFor: 'visiting' stamp: 'dkh 3/1/2012 14:27:24'!
visitClassDefinition: definition
    self subclassResponsibility! !

!MCFileTreeAbstractStWriter methodsFor: 'visiting' stamp: 'dkh 3/1/2012 14:27:24'!
visitClassTraitDefinition: definition
    self flag: #'skippedForNow'! !

!MCFileTreeAbstractStWriter methodsFor: 'visiting' stamp: 'dkh 3/1/2012 14:27:24'!
visitMetaclassDefinition: definition
    "handled by class definition"

    ! !

!MCFileTreeAbstractStWriter methodsFor: 'visiting' stamp: 'dkh 3/1/2012 14:27:24'!
visitMethodDefinition: definition
    self subclassResponsibility! !

!MCFileTreeAbstractStWriter methodsFor: 'visiting' stamp: 'dkh 3/1/2012 14:27:24'!
visitOrganizationDefinition: defintion
	self
		writeInDirectoryName: '.'
		fileName: 'categories'
		extension: '.st'
		visit: [ defintion categories do: [ :cat | stWriter writeCategory: cat ] ]! !

!MCFileTreeAbstractStWriter methodsFor: 'visiting' stamp: 'dkh 3/1/2012 14:27:24'!
visitScriptDefinition: definition
    self flag: #'skippedForNow'! !

!MCFileTreeAbstractStWriter methodsFor: 'visiting' stamp: 'dkh 3/1/2012 14:27:24'!
visitTraitDefinition: definition
    self flag: #'skippedForNow'! !

!MCFileTreeAbstractStWriter methodsFor: 'writing' stamp: 'dkh 3/1/2012 14:27:24'!
writeClassDefinition: definition
    stWriter writeClassDefinition: definition.
    definition hasClassInstanceVariables
        ifTrue: [ stWriter writeMetaclassDefinition: definition ].
    definition hasComment
        ifTrue: [ stWriter writeClassComment: definition ]! !

!MCFileTreeAbstractStWriter methodsFor: 'initialize-release' stamp: 'dkh 3/1/2012 14:27:24'!
writeDefinitions: aCollection
    "the correct initialization order is unknown if some classes are missing in the image"

    self writePropertiesFile.
    stWriter acceptVisitor: self forDefinitions: aCollection.
    self writeInitializers! !

!MCFileTreeAbstractStWriter methodsFor: 'visiting' stamp: 'dkh 3/1/2012 14:27:24'!
writeInDirectoryName: directoryNameOrPath fileName: fileName extension: ext visit: visitBlock
    | directory |
    directory := self directoryForDirectoryNamed: directoryNameOrPath.
    directory
        forceNewFileNamed: fileName , ext
        do: [ :file | 
            file lineEndConvention: #'lf'.
            stWriter stream: file.
            visitBlock value ]! !

!MCFileTreeAbstractStWriter methodsFor: 'initialize-release' stamp: 'dkh 3/1/2012 14:27:24'!
writeInitializers
	self
		writeInDirectoryName: '.'
		fileName: 'initializers'
		extension: '.st'
		visit: [ 
			stWriter
				writePresentInitializers;
				writeAbsentInitializers ] ! !

!MCFileTreeAbstractStWriter methodsFor: 'writing' stamp: 'dkh 3/1/2012 14:27:24'!
writeMethodDefinition: definition
    stWriter visitMethodDefinition: definition! !

!MCFileTreeAbstractStWriter methodsFor: 'initialize-release' stamp: 'dkh 3/1/2012 14:27:24'!
writePropertiesFile
    self
        writeInDirectoryName: '.'
        fileName: ''
        extension: '.filetree'
        visit: [ stWriter writeProperties ]! !

MCFileTreeAbstractStWriter subclass: #MCFileTreeStSnapshotWriter
	instanceVariableNames: 'classDefinitions methodDefinitions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

!MCFileTreeStSnapshotWriter methodsFor: 'accessing' stamp: 'dkh 3/1/2012 14:27:24'!
classDefinitions
    classDefinitions ifNil: [ classDefinitions := Dictionary new ].
    ^ classDefinitions! !

!MCFileTreeStSnapshotWriter methodsFor: 'accessing' stamp: 'dkh 3/1/2012 14:27:24'!
methodDefinitions
    methodDefinitions ifNil: [ methodDefinitions := Dictionary new ].
    ^ methodDefinitions! !

!MCFileTreeStSnapshotWriter methodsFor: 'visiting' stamp: 'dkh 3/1/2012 14:27:24'!
visitClassDefinition: definition
    orderedClassNames add: definition className.
    self classDefinitions at: definition actualClass put: definition! !

!MCFileTreeStSnapshotWriter methodsFor: 'visiting' stamp: 'dkh 3/1/2012 14:27:24'!
visitMethodDefinition: definition
    (self methodDefinitions
        at: definition actualClass
        ifAbsent: [ self methodDefinitions at: definition actualClass put: OrderedCollection new ]) add: definition! !

!MCFileTreeStSnapshotWriter methodsFor: 'writing' stamp: 'dkh 3/1/2012 14:27:24'!
writeClassDefinition: definition to: classPath
    self
        writeInDirectoryName: classPath
        fileName: definition className
        extension: '.st'
        visit: [ self writeClassDefinition: definition ]! !

!MCFileTreeStSnapshotWriter methodsFor: 'initialize-release' stamp: 'dkh 3/1/2012 14:27:24'!
writeDefinitions: aCollection
    | basePath extensionClasses extensionMethodDefinitions |
    super writeDefinitions: aCollection.
    basePath := 'snapshot' , FileDirectory slash , 'classes' , FileDirectory slash.
    extensionClasses := OrderedCollection new.
    extensionMethodDefinitions := OrderedCollection new.
    self methodDefinitions
        keysAndValuesDo: [ :class :extensionMethods | 
            self classDefinitions
                at: class theNonMetaClass
                ifAbsent: [ 
                    extensionClasses add: class.
                    extensionMethodDefinitions addAll: extensionMethods ] ].
    extensionClasses do: [ :class | self methodDefinitions removeKey: class ].
    self classDefinitions
        keysAndValuesDo: [ :class :definition | 
            | classPath methodPath |
            classPath := basePath , definition className , '.class' , FileDirectory slash.
            self writeClassDefinition: definition to: classPath.
            methodPath := classPath , 'instance' , FileDirectory slash.
            (self methodDefinitions at: class ifAbsent: [ #() ])
                do: [ :methodDefinition | self writeMethodDefinition: methodDefinition to: methodPath ].
            methodPath := classPath , 'class' , FileDirectory slash.
            (self methodDefinitions at: class theMetaClass ifAbsent: [ #() ])
                do: [ :methodDefinition | self writeMethodDefinition: methodDefinition to: methodPath ] ].
    basePath := 'snapshot' , FileDirectory slash , 'extensions' , FileDirectory slash.
    extensionMethodDefinitions
        do: [ :methodDefinition | 
            | methodPath |
            methodPath := basePath , methodDefinition className , '.class' , FileDirectory slash
                ,
                    (methodDefinition classIsMeta
                        ifTrue: [ 'class' ]
                        ifFalse: [ 'instance' ]) , FileDirectory slash.
            self writeMethodDefinition: methodDefinition to: methodPath ]! !

!MCFileTreeStSnapshotWriter methodsFor: 'writing' stamp: 'dkh 3/1/2012 14:27:24'!
writeMethodDefinition: methodDefinition to: methodPath
    | filename |
    filename := self fileNameForSelector: methodDefinition selector.
    self
        writeInDirectoryName: methodPath
        fileName: filename
        extension: '.st'
        visit: [ self writeMethodDefinition: methodDefinition ]! !

MCFileTreeAbstractStWriter subclass: #MCFileTreeStWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

!MCFileTreeStWriter methodsFor: 'visiting' stamp: 'dkh 3/1/2012 14:27:24'!
visitClassDefinition: definition
    orderedClassNames add: definition className.
    self
        writeInDirectoryName: definition className
        fileName: definition className
        extension: '.st'
        visit: [ self writeClassDefinition: definition ]! !

!MCFileTreeStWriter methodsFor: 'visiting' stamp: 'dkh 3/1/2012 14:27:24'!
visitMethodDefinition: definition
    | filename directoryname |
    directoryname := definition classIsMeta
        ifTrue: [ definition className , '_class' ]
        ifFalse: [ definition className ].
    filename := self fileNameForSelector: definition selector.
    self
        writeInDirectoryName: directoryname
        fileName: filename
        extension: '.st'
        visit: [ self writeMethodDefinition: definition ]! !

!MCMethodDefinition methodsFor: '*monticellofiletree-core' stamp: 'dkh 3/1/2012 14:27:24'!
= aDefinition
    ^ super = aDefinition
        and: [ 
            aDefinition source = self source
                and: [ 
                    aDefinition category = self category
                        and: [ 
                            "for now we'll ignore the timestamp in regards to method equality"
                            true
                                ifTrue: [ true ]
                                ifFalse: [ aDefinition timeStamp = self timeStamp ] ] ] ]! !

!MCMethodDefinition methodsFor: '*monticellofiletree-core' stamp: 'dkh 3/1/2012 14:27:24'!
setTimeStamp: aString
    ^ timeStamp := aString! !

!DirectoryEntryFile methodsFor: '*monticellofiletree-core' stamp: 'dkh 3/1/2012 14:27:24'!
readStreamDo: aBlock
	^ directory readOnlyFileNamed: self name do: aBlock! !

!MCVersionInfo methodsFor: '*monticellofiletree-core' stamp: 'dkh 3/1/2012 14:27:24'!
versionNumber
	^ ((self name copyAfterLast: $-) copyAfter: $.) asInteger ifNil: [ 0 ]! !

!MCFileRepositoryInspector methodsFor: '*monticellofiletree-core' stamp: 'dkh 3/1/2012 14:27:24'!
refresh
	| packageNames |
	packageNames := Set new.
	packageList := nil.
	versions := repository retrieveVersionsWithPackageNames: packageNames.
	newer := Set new.
	inherited := Set new.
	loaded := Set new.
	MCWorkingCopy allManagers
		do: [ :each | 
			| latest |
			each ancestors
				do: [ :ancestor | 
					loaded add: ancestor name.
					ancestor
						ancestorsDoWhileTrue: [ :heir | 
							(inherited includes: heir name)
								ifTrue: [ false ]
								ifFalse: [ 
									inherited add: heir name.
									true ] ] ].
			latest := (versions select: [ :v | v first = each package name ]) detectMax: [ :v | v third ].
			(latest notNil
				and: [ 
					each ancestors
						allSatisfy: [ :ancestor | 
							| av |
							av := ((ancestor name copyAfterLast: $-) copyAfter: $.) asInteger.
							av < latest third
								or: [ av = latest third and: [ ((ancestor name copyAfterLast: $-) copyUpTo: $.) ~= latest second ] ] ] ])
				ifTrue: [ newer add: each package name ] ].	"		select: [ :each | packageNames includes: each packageName]"
	self
		changed: #packageList;
		changed: #versionList! !

!MCRepository methodsFor: '*monticellofiletree-core' stamp: 'dkh 3/1/2012 14:27:24'!
retrieveVersionsWithPackageNames: packageNames
    ^ self readableFileNames
        collect: [ :each | 
            | name |
            name := (each copyUpToLast: $.) copyUpTo: $(.
            name last isDigit
                ifFalse: [ 
                    Array
                        with: name
                        with: ''
                        with: ''
                        with: each ]
                ifTrue: [ 
                    Array
                        with: (packageNames add: (name copyUpToLast: $-))
                        with: ((name copyAfterLast: $-) copyUpTo: $.)
                        with: ((name copyAfterLast: $-) copyAfter: $.) asInteger
                        with: each	"pkg name"	"user"	"version" ] ]! !

MCMczReader subclass: #MCFileTreeAbstractReader
	instanceVariableNames: 'packageDirectory packageProperties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

!MCFileTreeAbstractReader class methodsFor: 'reading' stamp: 'dkh 3/1/2012 14:27:24'!
on: s fileName: f
	^ (self on: s)
		packageDirectory: f;
		yourself! !

!MCFileTreeAbstractReader methodsFor: 'utilities' stamp: 'dkh 3/1/2012 14:27:24'!
addClassAndMethodDefinitionsFromDirectory: aDirectory
    self subclassResponsibility! !

!MCFileTreeAbstractReader methodsFor: 'utilities' stamp: 'dkh 3/1/2012 14:27:24'!
addClassAndMethodDefinitionsFromDirectoryEntries: entries
    | timestamp |
    self noMethodMetaData
        ifTrue: [ timestamp := self info author , ' ' , self info date mmddyyyy , ' ' , self info time print24 ].
    entries
        do: [ :element | 
            element isDirectory
                ifTrue: [ 
                    | directory |
                    directory := element asFileDirectory.
                    ((self separateMethodMetaAndSource or: [ self noMethodMetaData ])
                        ifTrue: [ directory entries select: [ :entry | entry name endsWith: '.st' ] ]
                        ifFalse: [ directory entries ])
                        do: [ :file | 
                            | methodDefinition |
                            (methodDefinition := self definitionFromFile: file inDirectory: directory)
                                ifNotNil: [ 
                                    methodDefinition isMethodDefinition
                                        ifTrue: [ 
                                            self separateMethodMetaAndSource
                                                ifTrue: [ 
                                                    directory
                                                        fileNamed: methodDefinition selector asString , '.meta'
                                                        do: [ :fileStream | methodDefinition setTimeStamp: (Author fixStamp: fileStream contents) ] ].
                                            self noMethodMetaData
                                                ifTrue: [ methodDefinition setTimeStamp: timestamp ] ].
                                    definitions add: methodDefinition ] ] ] ]! !

!MCFileTreeAbstractReader methodsFor: 'utilities' stamp: 'dkh 3/1/2012 14:27:24'!
addDefinitionFromFile: directoryEntry inDirectory: aDirectory
    (self definitionFromFile: directoryEntry inDirectory: aDirectory) ifNotNil: [ :def | definitions add: def ]! !

!MCFileTreeAbstractReader methodsFor: 'accessing' stamp: 'dkh 3/1/2012 14:27:24'!
basicVersion
	^ (MCVersion new)
		setPackage: self package
			info: self info
			snapshot: self snapshot
			dependencies: self dependencies;
		yourself! !

!MCFileTreeAbstractReader methodsFor: 'utilities' stamp: 'dkh 3/1/2012 14:27:24'!
definitionFromFile: directoryEntry inDirectory: aDirectory
    | defs reader |
    directoryEntry ifNil: [ ^ nil ].
    aDirectory
        fileNamed: directoryEntry name
        do: [ :fileStream | 
            | methodDefinition |
            reader := MCStReader on: fileStream.
            (defs := reader definitions) size <= 1
                ifFalse: [ self error: 'we should be writing exactly 1 definition per file' ] ].
    defs size = 0
        ifTrue: [ ^ nil ].
    ^ defs first! !

!MCFileTreeAbstractReader methodsFor: 'utilities' stamp: 'dkh 3/1/2012 14:27:24'!
loadDefinitions
    | entries |
    definitions := OrderedCollection new.
    entries := packageDirectory entries.
    self
        addDefinitionFromFile: (entries detect: [ :entry | entry name beginsWith: 'categories' ] ifNone: [  ])
            inDirectory: packageDirectory;
        addClassAndMethodDefinitionsFromDirectory: packageDirectory;
        addDefinitionFromFile: (entries detect: [ :entry | entry name beginsWith: 'initializers' ] ifNone: [  ])
            inDirectory: packageDirectory! !

!MCFileTreeAbstractReader methodsFor: 'utilities' stamp: 'dkh 3/1/2012 14:27:24'!
loadDependencies
	dependencies := Array new! !

!MCFileTreeAbstractReader methodsFor: 'testing' stamp: 'dkh 3/1/2012 14:27:24'!
noMethodMetaData
    ^ self packageProperties at: 'noMethodMetaData' ifAbsent: [ false ]! !

!MCFileTreeAbstractReader methodsFor: 'accessing' stamp: 'dkh 3/1/2012 14:27:24'!
packageDirectory: aByteString
	packageDirectory := stream directoryNamed: aByteString! !

!MCFileTreeAbstractReader methodsFor: 'accessing' stamp: 'dkh 3/1/2012 14:27:24'!
packageProperties
    packageProperties
        ifNil: [ 
            packageProperties := Dictionary new.
            (packageDirectory entries detect: [ :entry | entry name = '.filetree' ] ifNone: [  ])
                ifNotNil: [ :configEntry | 
                    configEntry
                        readStreamDo: [ :fileStream | 
                            | jsonObject structureVersion |
                            [ 
                            (jsonObject := MCFileTreeJsonParser parseStream: fileStream) isFloat
                                ifTrue: [ 
                                    "
							0.0 - original structure
							0.1 - separate files for method metaData (timestamp) and source
							0.2 - no method metaData file"
                                    packageProperties := Dictionary new.
                                    structureVersion := jsonObject printShowingDecimalPlaces: 1.
                                    packageProperties at: 'noMethodMetaData' put: structureVersion = '0.2'.
                                    packageProperties at: 'separateMethodMetaAndSource' put: structureVersion = '0.1' ]
                                ifFalse: [ 
                                    packageProperties := jsonObject.
                                    ((packageProperties at: 'noMethodMetaData' ifAbsent: [ false ])
                                        and: [ packageProperties at: 'separateMethodMetaAndSource' ifAbsent: [ false ] ])
                                        ifTrue: [ self error: 'noMethodMetaData and separateMethodMetaAndSource cannot both be true' ] ] ]
                                on: Error
                                do: [ :ex | 
                                    Transcript
                                        cr;
                                        show:
                                                'Error reading package properties (.filetree): ' , packageDirectory pathName , ' :: ' , ex description ] ] ] ].
    ^ packageProperties! !

!MCFileTreeAbstractReader methodsFor: 'utilities' stamp: 'dkh 3/1/2012 14:27:24'!
parseMember: fileName
	| tokens contents |
	contents := packageDirectory fileNamed: fileName do: [ :file | file contents ].
	tokens := (self scanner scanTokens: contents) first.
	^ self associate: tokens! !

!MCFileTreeAbstractReader methodsFor: 'testing' stamp: 'dkh 3/1/2012 14:27:24'!
separateMethodMetaAndSource
    ^ self packageProperties at: 'separateMethodMetaAndSource' ifAbsent: [ false ]! !

MCFileTreeAbstractReader subclass: #MCFileTreeStReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

!MCFileTreeStReader class methodsFor: 'accessing' stamp: 'dkh 3/1/2012 14:27:24'!
extension
	^ 'tree'! !

!MCFileTreeStReader methodsFor: 'utilities' stamp: 'dkh 3/1/2012 14:27:24'!
addClassAndMethodDefinitionsFromDirectory: aDirectory
    self addClassAndMethodDefinitionsFromDirectoryEntries: aDirectory entries! !

MCFileTreeAbstractReader subclass: #MCFileTreeStSnapshotReader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

!MCFileTreeStSnapshotReader class methodsFor: 'accessing' stamp: 'dkh 3/1/2012 14:27:24'!
extension
    ^ 'pkg'! !

!MCFileTreeStSnapshotReader methodsFor: 'utilities' stamp: 'dkh 3/1/2012 14:27:24'!
addClassAndMethodDefinitionsFromDirectory: aDirectory
    | snapshot classes entries extensions |
    snapshot := aDirectory directoryNamed: 'snapshot'.
    classes := snapshot directoryNamed: 'classes'.
    classes exists
        ifTrue: [ 
            self addClassAndMethodDefinitionsFromDirectoryEntries: (entries := classes entries).	"load .st files from subdirectories (*.class) of snapshot/classes ... class defintions"
            entries
                do: [ :classDirectoryEntry | 
                    | classDirectory |
                    classDirectory := classDirectoryEntry asFileDirectory.
                    self addClassAndMethodDefinitionsFromDirectoryEntries: classDirectory entries	"load .st files from subdirectories (class or instance) of snapshot/classes/*.class ... method definitions" ] ].
    extensions := snapshot directoryNamed: 'extensions'.
    extensions exists
        ifTrue: [ 
           extensions entries
                do: [ :classDirectoryEntry | 
                    | classDirectory |
                    classDirectory := classDirectoryEntry asFileDirectory.
                    self addClassAndMethodDefinitionsFromDirectoryEntries: classDirectory entries	"load .st files from subdirectories (class or instance) of snapshot/extensions/*.class ... method definitions" ] ].
! !

MCMczWriter subclass: #MCFileTreeWriter
	instanceVariableNames: 'directory packageFileDirectory cachedPackageFileDirectoryEntries'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

!MCFileTreeWriter class methodsFor: 'accessing' stamp: 'dkh 3/1/2012 14:27:24'!
readerClass
    "don't expect this message to be sent"

    self shouldNotImplement! !

!MCFileTreeWriter methodsFor: 'writing' stamp: 'dkh 3/1/2012 14:27:24'!
addString: string at: path
	string isEmpty
		ifFalse: [ 
			self packageFileDirectory forceNewFileNamed: path do: [:file | file nextPutAll: string]] ! !

!MCFileTreeWriter methodsFor: 'visiting' stamp: 'dkh 3/1/2012 14:27:24'!
deleteExistingPackageStructureFor: members
    "destroy .tree and .pkg directory structure .. otherwise it won't be pretty"

    | alternateDirName alternateDir |
    self packageFileDirectory exists
        ifTrue: [ self packageFileDirectory recursiveDelete ].
    alternateDirName := (self packageFileDirectory localName endsWith: '.pkg')
        ifTrue: [ members first , '.tree' ]
        ifFalse: [ 
            (self packageFileDirectory localName endsWith: '.tree')
                ifTrue: [ members first , '.pkg' ] ].
    alternateDirName
        ifNotNil: [ 
            alternateDir := stream directory directoryNamed: alternateDirName.
            alternateDir exists
                ifTrue: [ alternateDir recursiveDelete ] ]! !

!MCFileTreeWriter methodsFor: 'writing' stamp: 'dkh 3/1/2012 14:27:24'!
flush
	! !

!MCFileTreeWriter methodsFor: 'visiting' stamp: 'dkh 3/1/2012 14:27:24'!
initializePackageFileDirectoryCache
	cachedPackageFileDirectoryEntries := Dictionary new.
	self packageFileDirectory entries
		do: [ :entry | 
			entry isDirectory
				ifTrue: [ cachedPackageFileDirectoryEntries at: entry name put: entry asFileDirectory ] ]! !

!MCFileTreeWriter methodsFor: 'writing' stamp: 'dkh 3/1/2012 14:27:24'!
packageFileDirectory
    packageFileDirectory ifNil: [ packageFileDirectory := stream directory directoryNamed: directory ].
    ^ packageFileDirectory! !

!MCFileTreeWriter methodsFor: 'accessing' stamp: 'dkh 3/1/2012 14:27:24'!
snapshotWriterClass
	^ MCFileTreeAbstractStWriter! !

!MCFileTreeWriter methodsFor: 'visiting' stamp: 'dkh 3/1/2012 14:27:24'!
subPackageFileDirectoryFor: directoryNameOrPath
    ^ cachedPackageFileDirectoryEntries
        at: directoryNameOrPath
        ifAbsentPut: [ 
            | dir |
            dir := self packageFileDirectory directoryNamed: directoryNameOrPath.
            dir assureExistence.
            dir ]! !

!MCFileTreeWriter methodsFor: 'visiting' stamp: 'dkh 3/1/2012 14:27:24'!
writeSnapshot: aSnapshot
	(self snapshotWriterClass on: self) writeDefinitions: aSnapshot definitions! !

!MCFileTreeWriter methodsFor: 'visiting' stamp: 'dkh 3/1/2012 14:27:24'!
writeVersion: aVersion
    | members |
    directory := (members := MCFileTreeRepository parseName: aVersion info name) last.
    self deleteExistingPackageStructureFor: members.
    self packageFileDirectory assureExistence.
    self initializePackageFileDirectoryCache.
    super writeVersion: aVersion! !

MCStWriter subclass: #MCFileTreePackageStructureStWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

!MCFileTreePackageStructureStWriter class methodsFor: 'accessing' stamp: 'dkh 3/1/2012 14:27:24'!
useSnapShotWriter
    ^ MCFileTreeRepository defaultPackageExtension = '.pkg'! !

!MCFileTreePackageStructureStWriter methodsFor: 'accessing' stamp: 'dkh 3/1/2012 14:27:24'!
absentInitializers
	^ initializers reject: [ :each | Smalltalk hasClassNamed: each key ]! !

!MCFileTreePackageStructureStWriter methodsFor: 'visiting' stamp: 'dkh 3/1/2012 14:27:24'!
acceptVisitor: aVisitor forDefinitions: aCollection
	(MCDependencySorter sortItems: aCollection)
		do: [ :ea | ea accept: aVisitor ]
		displayingProgress: 'Writing definitions...'! !

!MCFileTreePackageStructureStWriter methodsFor: 'accessing' stamp: 'dkh 3/1/2012 14:27:24'!
initializers: aCollection
	initializers := aCollection! !

!MCFileTreePackageStructureStWriter methodsFor: 'accessing' stamp: 'dkh 3/1/2012 14:27:24'!
presentInitializers
	^ initializers select: [ :each | Smalltalk hasClassNamed: each key ]! !

!MCFileTreePackageStructureStWriter methodsFor: 'writing' stamp: 'dkh 3/1/2012 14:27:24'!
writeAbsentInitializers
	(self absentInitializers asSortedCollection: [ :a :b | a key <= b key ])
		do: [ :association | stream nextPutAll: association value contents ]! !

!MCFileTreePackageStructureStWriter methodsFor: 'writing' stamp: 'dkh 3/1/2012 14:27:24'!
writeClassDefinition: definition
    self chunkContents: [ :s | definition printDefinitionOn: s ]! !

!MCFileTreePackageStructureStWriter methodsFor: 'writing' stamp: 'dkh 3/1/2012 14:27:24'!
writeDefinitions: aCollection
	"the correct initialization order is unknown if some classes are missing in the image"

	initializers := Set new.
	self
		acceptVisitor: self forDefinitions: aCollection;
		writePresentInitializers;
		writeAbsentInitializers! !

!MCFileTreePackageStructureStWriter methodsFor: 'writing' stamp: 'dkh 3/1/2012 14:27:24'!
writeMethodPreamble: definition
    stream
        cr;
        nextPut: $!!;
        nextPutAll: definition fullClassName;
        nextPutAll: ' methodsFor: ';
        nextPutAll: definition category asString printString;
        nextPutAll: '!!';
        cr! !

!MCFileTreePackageStructureStWriter methodsFor: 'writing' stamp: 'dkh 3/1/2012 14:27:24'!
writePresentInitializers
	| orderedClasses presentInitializers |
	presentInitializers := self presentInitializers.
	orderedClasses := (Class
		superclassOrder: (presentInitializers collect: [ :each | Smalltalk classOrTraitNamed: each key ]))
		collect: [ :each | each name ].
	orderedClasses
		do: [ :className | stream nextPutAll: (presentInitializers detect: [ :each | each key = className ]) value contents ]! !

!MCFileTreePackageStructureStWriter methodsFor: 'writing' stamp: 'dkh 3/1/2012 14:27:24'!
writeProperties
    stream
        nextPut: ${;
        cr;
        nextPutAll: '    "noMethodMetaData" : true,';
        cr;
        nextPutAll: '    "separateMethodMetaAndSource" : false';
        cr;
        nextPut: $};
        cr! !

MCDirectoryRepository subclass: #MCFileTreeRepository
	instanceVariableNames: 'readonly repositoryProperties'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

MCFileTreeRepository class
	instanceVariableNames: 'defaultPackageExtension'!

MCFileTreeRepository class
	instanceVariableNames: 'defaultPackageExtension'!

!MCFileTreeRepository class methodsFor: 'accessing' stamp: 'dkh 3/1/2012 14:27:24'!
defaultPackageExtension
    ".tree and .pkg are the only two formats supported at the moment.

	default package extension is primary driver fo  format in which package structure is written"

    defaultPackageExtension ifNil: [ defaultPackageExtension := '.tree' ].
    ^ defaultPackageExtension! !

!MCFileTreeRepository class methodsFor: 'accessing' stamp: 'dkh 3/1/2012 14:27:24'!
defaultPackageExtension: aString
    ".tree and .pkg are the only two formats supported at the moment"

    (#('.tree' '.pkg') includes: aString)
        ifFalse: [ self error: 'Unsupported package extension: ' , aString printString ].
    defaultPackageExtension := aString! !

!MCFileTreeRepository class methodsFor: 'instance creation' stamp: 'dkh 3/1/2012 14:27:24'!
description
    ^ 'filetree://'! !

!MCFileTreeRepository class methodsFor: 'utility' stamp: 'dkh 3/1/2012 14:27:24'!
parseName: aString
    ^ self parseName: aString extension: self defaultPackageExtension! !

!MCFileTreeRepository class methodsFor: 'utility' stamp: 'dkh 3/1/2012 14:27:24'!
parseName: aString extension: extension
    "picked up from GoferVersionReference>>parseName:"

    | info basicName package branch author versionNumber packageName |
    basicName := aString last isDigit
        ifTrue: [ aString ]
        ifFalse: [ (aString copyUpToLast: $.) copyUpTo: $( ].
    package := basicName copyUpToLast: $-.
    (package includes: $.)
        ifFalse: [ branch := '' ]
        ifTrue: [ 
            branch := '.' , (package copyAfter: $.).
            package := package copyUpTo: $. ].
    author := (basicName copyAfterLast: $-) copyUpToLast: $..
    versionNumber := (basicName copyAfterLast: $-) copyAfterLast: $..
    (versionNumber notEmpty and: [ versionNumber allSatisfy: [ :each | each isDigit ] ])
        ifTrue: [ versionNumber := versionNumber asNumber ]
        ifFalse: [ versionNumber := 0 ].
    packageName := package , branch.
    ^ {packageName.
    author.
    versionNumber.
    (packageName , extension)}! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'dkh 3/1/2012 14:27:24'!
allFileNames
	^(directory entries select: [:entry | entry isDirectory and: [self canReadFileNamed: entry name]]) collect: [:entry | entry name]! !

!MCFileTreeRepository methodsFor: 'accessing' stamp: 'dkh 3/1/2012 14:27:24'!
asRepositorySpecFor: aMetacelloMCProject
    ^ aMetacelloMCProject repositorySpec
        description: self description;
        type: 'filetree';
        yourself! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'dkh 3/1/2012 14:27:24'!
basicStoreVersion: aVersion
    self readonly
        ifTrue: [ ^ self error: 'The filetree repository: ' , self description printString , ' was created read only.' ].
    (self packageExtension = '.tree' and: [ self class defaultPackageExtension ~= '.tree' ])
        ifTrue: [ 
            repositoryProperties := nil.	"force reset of properties, since we're rewriting the file"
            self writeRepositoryProperties ].
    MCFileTreeWriter fileOut: aVersion on: self! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'dkh 3/1/2012 14:27:24'!
cachedFileNames
	^ #()! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'dkh 3/1/2012 14:27:24'!
canReadFileNamed: aString
    ^ (aString endsWith: self packageExtension) or: [ aString endsWith: '.tree' ]! !

!MCFileTreeRepository methodsFor: 'descriptions' stamp: 'dkh 3/1/2012 14:27:24'!
description
    ^ self class description , super description! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'dkh 3/1/2012 14:27:24'!
directory: aDirectory
    super directory: aDirectory.
    self repositoryProperties isEmpty
        ifTrue: [ self writeRepositoryProperties ]! !

!MCFileTreeRepository methodsFor: 'accessing' stamp: 'dkh 3/1/2012 14:27:24'!
directoryFrom: aDirectory
	self directory: (FileDirectory on: aDirectory)! !

!MCFileTreeRepository methodsFor: 'actions' stamp: 'dkh 3/1/2012 14:27:24'!
fileDirectoryOn: fileName
	^ FileDirectory on: (directory fullNameFor: fileName)! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'dkh 3/1/2012 14:27:24'!
goferVersionFrom: aVersionReference
    "until we no longer find .tree directories in the wild"

    ((self readableFileNames collect: [ :fileName | self fileDirectoryOn: fileName ])
        select: [ :packageDirectory | packageDirectory exists ])
        collect: [ :packageDirectory | 
            (self versionInfoForPackageDirectory: packageDirectory) name = aVersionReference name
                ifTrue: [ ^ self loadVersionFromFileNamed: packageDirectory localName ] ].
    ^ nil! !

!MCFileTreeRepository methodsFor: 'accessing' stamp: 'dkh 3/1/2012 14:27:24'!
metacelloProjectClass
    ^ MetacelloFileTreeProject! !

!MCFileTreeRepository methodsFor: 'actions' stamp: 'dkh 3/1/2012 14:27:24'!
packageDescriptionFromPackageDirectory: packageDirectory
    | filename info extension |
    filename := packageDirectory localName.
    extension := filename copyFrom: (filename lastIndexOf: $. ifAbsent: [ '' ]) to: filename size.
    info := self versionInfoForPackageDirectory: packageDirectory.
    ^ self parseName: info name extension: extension! !

!MCFileTreeRepository methodsFor: 'actions' stamp: 'dkh 3/1/2012 14:27:24'!
packageDescriptionsFromReadableFileNames
	^ ((self readableFileNames collect: [ :fileName | self fileDirectoryOn: fileName ])
		select: [ :packageDirectory | packageDirectory exists ])
		collect: [ :packageDirectory | self packageDescriptionFromPackageDirectory: packageDirectory ]! !

!MCFileTreeRepository methodsFor: 'private' stamp: 'dkh 3/1/2012 14:27:24'!
packageExtension
    ^ self repositoryProperties at: 'packageExtension' ifAbsent: [ '.tree' ]! !

!MCFileTreeRepository methodsFor: 'private' stamp: 'dkh 3/1/2012 14:27:24'!
parseName: aString extension: extension
    ^ self class parseName: aString extension: extension! !

!MCFileTreeRepository methodsFor: 'i/o' stamp: 'dkh 3/1/2012 14:27:24'!
readStreamForFileNamed: aString do: aBlock
	^ aBlock value: directory! !

!MCFileTreeRepository methodsFor: 'accessing' stamp: 'dkh 3/1/2012 14:27:24'!
readonly
    readonly ifNil: [ readonly := false ].
    ^ readonly! !

!MCFileTreeRepository methodsFor: 'accessing' stamp: 'dkh 3/1/2012 14:27:24'!
readonly: anObject
	readonly := anObject! !

!MCFileTreeRepository methodsFor: 'accessing' stamp: 'dkh 3/1/2012 14:27:24'!
repositoryProperties
    repositoryProperties
        ifNil: [ 
            repositoryProperties := Dictionary new.
            (directory entries detect: [ :entry | entry name = '.filetree' ] ifNone: [  ])
                ifNotNil: [ :configEntry | 
                    configEntry
                        readStreamDo: [ :fileStream | 
                            [ repositoryProperties := MCFileTreeJsonParser parseStream: fileStream ]
                                on: Error
                                do: [ :ex | 
                                    Transcript
                                        cr;
                                        show:
                                                'Error reading repository properties (.filetree): ' , directory pathName , ' :: ' , ex description ] ] ] ].
    ^ repositoryProperties! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'dkh 3/1/2012 14:27:24'!
versionFromFileNamed: aString
	^ self loadVersionFromFileNamed: aString! !

!MCFileTreeRepository methodsFor: 'actions' stamp: 'dkh 3/1/2012 14:27:24'!
versionInfoForPackageDirectory: packageDirectory
    ^ ((MCReader readerClassForFileNamed: packageDirectory localName)
        on: packageDirectory containingDirectory
        fileName: packageDirectory localName)
        loadVersionInfo;
        info! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'dkh 3/1/2012 14:27:24'!
versionInfoFromFileNamed: aString
	^ self loadVersionInfoFromFileNamed: aString! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'dkh 3/1/2012 14:27:24'!
versionNameFromFileName: aString
	| description |
	description := self packageDescriptionFromPackageDirectory: (self fileDirectoryOn: aString).
	^ description first , '-' , description second , '.' , description third printString! !

!MCFileTreeRepository methodsFor: 'interface' stamp: 'dkh 3/1/2012 14:27:24'!
versionWithInfo: aVersionInfo ifAbsent: errorBlock
	(self allFileNamesForVersionNamed: aVersionInfo name)
		ifNotEmpty: [ :aCollection | ^ self versionFromFileNamed: aCollection first ].
	^ errorBlock value! !

!MCFileTreeRepository methodsFor: 'as yet unclassified' stamp: 'dkh 3/1/2012 14:27:24'!
writeRepositoryProperties
    directory
        forceNewFileNamed: '.filetree'
        do: [ :file | 
            file lineEndConvention: #'lf'.
            file
                nextPutAll: '{ "packageExtension" : "' , self class defaultPackageExtension , '" }';
                cr ]! !

!MCFileTreeRepository methodsFor: 'i/o' stamp: 'dkh 3/1/2012 14:27:24'!
writeStreamForFileNamed: aString replace: aBoolean do: aBlock
	self error: 'we do not open a single stream, but write multiple files'! !

Object subclass: #MCFileTreeJsonParser
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MonticelloFileTree-Core'!

!MCFileTreeJsonParser class methodsFor: 'instance creation' stamp: 'dkh 3/1/2012 14:27:24'!
new
	self error: 'Instantiate the parser with a stream.'! !

!MCFileTreeJsonParser class methodsFor: 'instance creation' stamp: 'dkh 3/1/2012 14:27:24'!
on: aStream
	^ self basicNew initializeOn: aStream! !

!MCFileTreeJsonParser class methodsFor: 'accessing' stamp: 'dkh 3/1/2012 14:27:24'!
parse: aString
	^ self parseStream: aString readStream! !

!MCFileTreeJsonParser class methodsFor: 'accessing' stamp: 'dkh 3/1/2012 14:27:24'!
parseStream: aStream
	^ (self on: aStream) parse! !

!MCFileTreeJsonParser methodsFor: 'adding' stamp: 'dkh 3/1/2012 14:27:24'!
addProperty: anAssociation to: anObject
	"Add the property anAssociation described with key and value to anObject. Subclasses might want to refine this implementation."
	
	^ anObject 
		add: anAssociation;
		yourself! !

!MCFileTreeJsonParser methodsFor: 'adding' stamp: 'dkh 3/1/2012 14:27:24'!
addValue: anObject to: aCollection
	"Add anObject to aCollection. Subclasses might want to refine this implementation."

	^ aCollection copyWith: anObject! !

!MCFileTreeJsonParser methodsFor: 'creating' stamp: 'dkh 3/1/2012 14:27:24'!
createArray
	"Create an empty collection. Subclasses might want to refine this implementation."

	^ Array new! !

!MCFileTreeJsonParser methodsFor: 'creating' stamp: 'dkh 3/1/2012 14:27:24'!
createFalse
	"Create the false literal. Subclasses might want to refine this implementation."
	
	^ false! !

!MCFileTreeJsonParser methodsFor: 'creating' stamp: 'dkh 3/1/2012 14:27:24'!
createNull
	"Create the null literal. Subclasses might want to refine this implementation."

	^ nil! !

!MCFileTreeJsonParser methodsFor: 'creating' stamp: 'dkh 3/1/2012 14:27:24'!
createNumber: aString
	"Create a number literal. Subclasses might want to refine this implementation."

	^ aString asNumber! !

!MCFileTreeJsonParser methodsFor: 'creating' stamp: 'dkh 3/1/2012 14:27:24'!
createObject
	"Create an empty object. Subclasses might want to refine this implementation."
	
	^ Dictionary new! !

!MCFileTreeJsonParser methodsFor: 'creating' stamp: 'dkh 3/1/2012 14:27:24'!
createProperty: aKey with: aValue
	"Create an empty attribute value pair. Subclasses might want to refine this implementation."
	
	^ aKey -> aValue! !

!MCFileTreeJsonParser methodsFor: 'creating' stamp: 'dkh 3/1/2012 14:27:24'!
createString: aString
	"Create a string literal. Subclasses might want to refine this implementation."

	^ aString! !

!MCFileTreeJsonParser methodsFor: 'creating' stamp: 'dkh 3/1/2012 14:27:24'!
createTrue
	"Create the true literal. Subclasses might want to refine this implementation."

	^ true! !

!MCFileTreeJsonParser methodsFor: 'private' stamp: 'dkh 3/1/2012 14:27:24'!
error: aString
	"Raise a parse error labelled aString."

	^ JSJsonSyntaxError signal: aString! !

!MCFileTreeJsonParser methodsFor: 'private' stamp: 'dkh 3/1/2012 14:27:24'!
expect: aString
	"Expects aString and consume input, throw an error otherwise."

	^ (self match: aString) ifFalse: [ self error: aString , ' expected' ]! !

!MCFileTreeJsonParser methodsFor: 'initialization' stamp: 'dkh 3/1/2012 14:27:24'!
initializeOn: aStream
	self initialize.
	stream := aStream! !

!MCFileTreeJsonParser methodsFor: 'private' stamp: 'dkh 3/1/2012 14:27:24'!
match: aString
	"Tries to match aString, consume input and answer true if successful."
	
	| position |
	position := stream position.
	aString do: [ :each |
		(stream atEnd or: [ stream next ~= each ]) ifTrue: [ 
			stream position: position.
			^ false ] ].
	self whitespace.
	^ true! !

!MCFileTreeJsonParser methodsFor: 'parsing' stamp: 'dkh 3/1/2012 14:27:24'!
parse
	| result |
	result := self whitespace; parseValue.
	stream atEnd
		ifFalse: [ self error: 'end of input expected' ].
	^ result! !

!MCFileTreeJsonParser methodsFor: 'parsing' stamp: 'dkh 3/1/2012 14:27:24'!
parseArray
	| result |
	self expect: '['.
	result := self createArray.
	(self match: ']')
		ifTrue: [ ^ result ].
	[ stream atEnd ] whileFalse: [
		result := self
			addValue: self parseValue
			to: result.
		(self match: ']') 
			ifTrue: [ ^ result ].
		self expect: ',' ].
	self error: 'end of array expected'! !

!MCFileTreeJsonParser methodsFor: 'parsing-internal' stamp: 'dkh 3/1/2012 14:27:24'!
parseCharacter
	| char |
	(char := stream next) = $\ 
		ifFalse: [ ^ char ].
	(char := stream next) = $" 
		ifTrue: [ ^ char ].
	char = $\
		ifTrue: [ ^ char ].
	char = $/
		ifTrue: [ ^ char ].
	char = $b
		ifTrue: [ ^ Character backspace ].
	char = $f
		ifTrue: [ ^ Character newPage ].
	char = $n
		ifTrue: [ ^ Character lf ].
	char = $r
		ifTrue: [ ^ Character cr ].
	char = $t
		ifTrue: [ ^ Character tab ].
	char = $u
		ifTrue: [ ^ self parseCharacterHex ].
	self error: 'invalid escape character \' , (String with: char)! !

!MCFileTreeJsonParser methodsFor: 'parsing-internal' stamp: 'dkh 3/1/2012 14:27:24'!
parseCharacterHex
	| value |
	value := self parseCharacterHexDigit.
	3 timesRepeat: [ value := (value << 4) + self parseCharacterHexDigit ].
	^ Character codePoint: value! !

!MCFileTreeJsonParser methodsFor: 'parsing-internal' stamp: 'dkh 3/1/2012 14:27:24'!
parseCharacterHexDigit
	| digit |
	stream atEnd ifFalse: [ 
		digit := stream next greaseInteger.
		(digit between: "$0" 48 and: "$9" 57)
			ifTrue: [ ^ digit - 48 ].
		(digit between: "$A" 65 and: "$F" 70)
			ifTrue: [ ^ digit - 55 ].
		(digit between: "$a" 97 and: "$f" 102)
			ifTrue: [ ^ digit - 87 ] ].
	self error: 'hex-digit expected'! !

!MCFileTreeJsonParser methodsFor: 'parsing-internal' stamp: 'dkh 3/1/2012 14:27:24'!
parseNumber
	| negated number |
	negated := stream peek = $-.
	negated ifTrue: [ stream next ].
	number := self parseNumberInteger.
	(stream peek = $.) ifTrue: [
		stream next. 
		number := number + self parseNumberFraction ].
	(stream peek = $e or: [ stream peek = $E ]) ifTrue: [
		stream next.
		number := number * self parseNumberExponent ].
	negated ifTrue: [ number := number negated ].
	^ self whitespace; createNumber: number! !

!MCFileTreeJsonParser methodsFor: 'parsing-internal' stamp: 'dkh 3/1/2012 14:27:24'!
parseNumberExponent
	| number negated |
	number := 0.
	negated := stream peek = $-.
	(negated or: [ stream peek = $+ ]) ifTrue: [ stream next ].
	[ stream atEnd not and: [ stream peek isDigit ] ]
		whileTrue: [ number := 10 * number + (stream next greaseInteger - 48) ].
	negated ifTrue: [ number := number negated ].
	^ 10 raisedTo: number! !

!MCFileTreeJsonParser methodsFor: 'parsing-internal' stamp: 'dkh 3/1/2012 14:27:24'!
parseNumberFraction
	| number power |
	number := 0.
	power := 1.0.
	[ stream atEnd not and: [ stream peek isDigit ] ] whileTrue: [
		number := 10 * number + (stream next greaseInteger - 48).
		power := power * 10.0 ].
	^ number / power! !

!MCFileTreeJsonParser methodsFor: 'parsing-internal' stamp: 'dkh 3/1/2012 14:27:24'!
parseNumberInteger
	| number |
	number := 0.
	[ stream atEnd not and: [ stream peek isDigit ] ]
		whileTrue: [ number := 10 * number + (stream next greaseInteger - 48) ].
	^ number! !

!MCFileTreeJsonParser methodsFor: 'parsing' stamp: 'dkh 3/1/2012 14:27:24'!
parseObject
	| result |
	self expect: '{'.
	result := self createObject.
	(self match: '}')
		ifTrue: [ ^ result ].
	[ stream atEnd ] whileFalse: [
		result := self
			addProperty: self parseProperty
			to: result.
		(self match: '}')
			ifTrue: [ ^ result ].
		self expect: ',' ].
	self error: 'end of object expected'! !

!MCFileTreeJsonParser methodsFor: 'parsing-internal' stamp: 'dkh 3/1/2012 14:27:24'!
parseProperty
	| name value |
	name := self parseString.
	self expect: ':'.
	value := self parseValue.
	^ self createProperty: name with: value.! !

!MCFileTreeJsonParser methodsFor: 'parsing-internal' stamp: 'dkh 3/1/2012 14:27:24'!
parseString
	| result |
	self expect: '"'.
	result := WriteStream on: String new.
	[ stream atEnd or: [ stream peek = $" ] ] 
		whileFalse: [ result nextPut: self parseCharacter ].
	^ self expect: '"'; createString: result contents! !

!MCFileTreeJsonParser methodsFor: 'parsing' stamp: 'dkh 3/1/2012 14:27:24'!
parseValue
	| char |
	stream atEnd ifFalse: [ 
		char := stream peek.
		char = ${
			ifTrue: [ ^ self parseObject ].
		char = $[
			ifTrue: [ ^ self parseArray ].
		char = $"
			ifTrue: [ ^ self parseString ].
		(char = $- or: [ char between: $0 and: $9 ])
			ifTrue: [ ^ self parseNumber ].
		(self match: 'true')
			ifTrue: [ ^ self createTrue ].
		(self match: 'false')
			ifTrue: [ ^ self createFalse ].
		(self match: 'null')
			ifTrue: [ ^ self createNull ] ].
	self error: 'invalid input'! !

!MCFileTreeJsonParser methodsFor: 'private' stamp: 'dkh 3/1/2012 14:27:24'!
whitespace
	"Strip whitespaces from the input stream."

	[ stream atEnd not and: [ stream peek isSeparator ] ]
		whileTrue: [ stream next ]! !

!MCFileBasedRepository methodsFor: '*monticellofiletree-core' stamp: 'dkh 3/1/2012 14:27:24'!
packageDescriptionsFromReadableFileNames
	^ self readableFileNames
		collect: [ :each | 
			| name |
			name := (each copyUpToLast: $.) copyUpTo: $(.
			name last isDigit
				ifFalse: [ 
					{name.
					''.
					''.
					each} ]
				ifTrue: [ 
					| packageName author versionNumber |
					packageName := name copyUpToLast: $-.
					author := (name copyAfterLast: $-) copyUpTo: $..
					versionNumber := ((name copyAfterLast: $-) copyAfter: $.) asInteger ifNil: [ 0 ].
					{packageName.
					author.
					versionNumber.
					each} ] ]! !

!MCFileBasedRepository methodsFor: '*monticellofiletree-core' stamp: 'dkh 3/1/2012 14:27:24'!
retrieveVersionsWithPackageNames: packageNames
	| packageDescriptions |
	packageDescriptions := self packageDescriptionsFromReadableFileNames.
	packageNames addAll: (packageDescriptions collect: [ :packageDescription | packageDescription first ]).
	^ packageDescriptions select: [ :each | (each at: 3) isNumber ]! !
